//QUERY = "%23InDesign";

var csInterface = new CSInterface();
var showMessages = false;
var showRenderedXmlContent = false;
var isDemo = true;


function start() {
    
    createFlyoutMenu();
    
    // Die Einstellungen für das UI setzen
    themeManager.init();
    
     // Zugangsdaten WordPress vom LocalStorage laden
    getWordpressSettings();
    
    // Internetverbindung und Wordpress Response testen
    checkConnection();
      
    // Temporary DownloadFolder für Bilder und XML erstellen 
    createTempFolder();
    
    // Wenn Connection OK
    loadPosts();
    
    if (showMessages) setMessage("Init abgeschlossen.");

}


function getWordpressSettings() {
      
    var url = localStorage.getItem("url");
    if (url === "") url = "[wordpress.test.de]";
    
    var username = localStorage.getItem("username");
    if (username === "") username = "[Benutzername]";
    
    var password = localStorage.getItem("password");
    if (password === "") password = "[Passwort]";
    
    var postid = localStorage.getItem("postid");
    if (postid === "") postid = "[Post-ID]";
    
    var template = localStorage.getItem("template");
    if (template === "") template = "[template.indt]";

    if (showMessages) setMessage("localStorage URL: " + url);

    document.getElementById("url").value = url;
    document.getElementById("username").value = username;
    document.getElementById("password").value = password;
    document.getElementById("postid").value = postid;
    document.getElementById("template").value = template;
    
    if ( !(url ==  "[wordpress.test.de]" 
           || username == "[Benutzername]" 
           || password == "[Passwort]" ) ) {
        
            $("#item_list").html('<div align="center"><img src="./css/images/loading.gif" /></div>');
        
    }
    
}

function checkConnection() {
    
    if (navigator.onLine === true) {
      setMessage("Internetverbindung vorhanden!");
    } else {
        setMessage("Keine Internetverbindung!");
        return false;
    }

    
    var WPAPI = require( 'wpapi' );
    var curEndpoint = "http://" + document.getElementById("url").value + "/wp-json";
    var curUsername = document.getElementById("username").value;    
    var curPassword = document.getElementById("password").value;
    
    var wp = new WPAPI({ 
        endpoint: curEndpoint, 
        username: curUsername,
        password: curPassword,
        auth: true
    });
       
    wp.posts().get(function(err, response) {
            
            if ( err ) {
                setMessage("Fehlende Konfiguration oder keine Internetverbindung!");
                //process.exit(1);
                // handle err 
            }
        
    });
    
}

function createTempFolder() {
    
     // Create WordPress-Temp Folder
    try {
        var fs = require('fs');	
        var csInterface = new CSInterface();
        var myDocumentsFolder = csInterface.getSystemPath(SystemPath.MY_DOCUMENTS);
        var curTempFolder = myDocumentsFolder + '/WordPress-Temp';

        if (!fs.existsSync(curTempFolder)) {
            fs.mkdirSync(curTempFolder);
            if (showMessages) setMessage("WordPress-Temp folder created successfully.");
        } else {
            if (showMessages) setMessage("WordPress-Temp folder exists.");
        }

        //curDownloadFolder = dir;
        if (showMessages) setMessage("curDownloadFolder: " + curTempFolder);

    } catch (e) {
        if (showMessages) setMessage("Create WordPress-Temp folder failed.");

    }
    
}


function setMessage(string) {
    
    document.getElementById("message").textContent = string + "\r" + document.getElementById("message").textContent;
}


function clearMessage() {
    document.getElementById("message").textContent = "";
}

function downloadPost() {
    
    //createDocument();
    
    var curEndpoint = "http://" + document.getElementById("url").value + "/wp-json";
    var curUsername = document.getElementById("username").value;
    var curPassword = document.getElementById("password").value;
    var curPostid = document.getElementById("postid").value;

    // get ID
    var curID = curPostid;
    if (curID == "[Post-ID]") setMessage("Keine Auswahl oder Download Beitrag nicht möglich.");
  
    try {
        var WPAPI = require('wpapi');
        if (showMessages) setMessage("wpapi enabled");
    } catch(e) {
        if (showMessages) setMessage("wpapi disabled");      
    }

 
    var wp = new WPAPI({ 
        endpoint: curEndpoint, 
        username: curUsername,
        password: curPassword,
        auth: true
    });
    
    // embed() für die Einbettung der Beitragsbilder / Featured Media
    wp.posts().id( curID ).embed().get(function( err, response ) {
        
        if ( err ) {
            setMessage("Fehler bei Download."); 
        } else {
           createDocument(); 
        }
      
        var txtResponse = JSON.stringify(response);
        if (showMessages) setMessage("txtResponse: " + txtResponse);

        // ID
        var curID = response.id;
        var nameID = "id";
        curID = curID.toString();
        if (showMessages) setMessage("id: " + curID);
        
        // Datum
        var curDate = response.date;
        var nameDate = "date";
        curDate = curDate.toString();
        if (showMessages) setMessage("date: " + curDate);
        
        // Die guid
        var curGuid = response.guid.rendered;
        var nameGuid = "guid";
        curGuid = curGuid.toString();
        if (showMessages) setMessage("guid.rendered: " + curGuid);
        
        // Der Titel
        var curTitle = response.title.rendered;
        var nameTitle = "title";
        curTitle = curTitle.toString();
        if (showMessages) setMessage("title.rendered: " + curTitle);
        
        // Der Lauftext    
        var nameContent = "content";

        var curContent = response.content.rendered;
        
        // Ersetzen eines Non-Breaking Space durch ein Leerzeichen
        curContent = curContent.replace("&nbsp;"," ");
        
        
        // DTD
        var dtd = "<!DOCTYPE WORDPRESS [ \n <!ENTITY ndash '&#8211;'> \n <!ENTITY mdash '&#8212;'> \n <!ENTITY lsquo '&#8216;'> \n <!ENTITY rsquo '&#8217;'> \n <!ENTITY ldquo '&#8220;'> \n <!ENTITY rdquo '&#8221;'> \n <!ENTITY bdquo '&#8222;'> \n <!ENTITY bull  '&#8226;'> \n <!ENTITY hellip  '&#8230;'> ]>";

        
        var xmlString = "<?xml version='1.0' encoding='UTF-8'?>" + dtd + "\n<Root><content>" + curContent + "</content>\n</Root>";
        
        
        if (showRenderedXmlContent) setMessage("xml content.rendered: " + xmlString);
        
        var csInterface = new CSInterface();
        var curTempFolder = csInterface.getSystemPath(SystemPath.MY_DOCUMENTS) + '/WordPress-Temp';
        
        // save XML to File
        var fileName = "WordPress-Temp.xml";

        if (showMessages) setMessage("curFileName: " + fileName );

        var fullPath = curTempFolder + "/" + fileName;
        if (showMessages) setMessage("Full Path: " + fullPath);

        if (showMessages) setMessage("\rwriting XML to file\r");
        // Datei schreiben
        
        var fs = require("fs");
        var wStream = fs.createWriteStream(fullPath);
        wStream.write(xmlString);
        wStream.end('');
        wStream.on("finish", function() {
            
                if (showMessages) setMessage("+++FINISH+++");
                // pipe done here, do something with file

                var csInterface = new CSInterface();
                var curTempFolder = csInterface.getSystemPath(SystemPath.MY_DOCUMENTS) + '/WordPress-Temp';

                // save XML to File
                var fileName = "WordPress-Temp.xml";

                if (showMessages) setMessage("curFileName: " + fileName );

                var fullPath = curTempFolder + "/" + fileName;
                if (showMessages) setMessage("Full Path: " + fullPath);

                var evalString = "placeContentOnStage(\"" + fullPath+ "\")";

                if (showMessages) setMessage("placing Content on stage");
                if (showMessages) setMessage("evalString placeContent on Stage: " + evalString);

                csInterface.evalScript(evalString, function(result){

                    if (result != "") {
                        if (showMessages) setMessage(result);
                    } else {
                        if (showMessages) setMessage("result ohne Inhalt.");
                    }
                });
            
                setMessage("Download WordPress Beitrag abgeschlossen: [" + curID + "]" );
        });
        
        
         // +++ ID, Datum und GUID platzieren +++++ 
        
        //var csInterface = new CSInterface();
        
        var evalString = "placeItem(\"" + curID + "\"" + ",\"" + nameID + "\")";
        
        csInterface.evalScript(evalString, function(result){

            if (result != "") {
                if (showMessages) setMessage(result);
            } else {
                if (showMessages) setMessage("result ohne Inhalt.");
            }
        });
        

        var evalString = "placeItem(\"" + curDate + "\"" + ",\"" + nameDate + "\")";
        
        csInterface.evalScript(evalString, function(result){

            if (result != "") {
                if (showMessages) setMessage(result);
            } else {
                if (showMessages) setMessage("result ohne Inhalt.");
            }
        });
 

        var evalString = "placeItem(\"" + curGuid + "\"" + ",\"" + nameGuid + "\")";
        
        csInterface.evalScript(evalString, function(result){

            if (result != "") {
                if (showMessages) setMessage(result);
            } else {
                if (showMessages) setMessage("result ohne Inhalt.");
            }
        });
        
        var evalString = "placeItem(\"" + curTitle + "\"" + ",\"" + nameTitle + "\")";
        
        csInterface.evalScript(evalString, function(result){

            if (result != "") {
                if (showMessages) setMessage(result);
            } else {
                if (showMessages) setMessage("result ohne Inhalt.");
            }
        });
        
        
        evalString = "createHyperlink()";
        
        csInterface.evalScript(evalString, function(result){

            if (result != "") {
                if (showMessages) setMessage(result);
            } else {
                if (showMessages) setMessage("result ohne Inhalt.");
            }
        });
        
        
        
        // ++++++++++++++++
             
        // Das Inline Bild im Text
        var curHTMLContent = response.content.rendered;
        //var nameImage = "image";
        
        var div = document.createElement('div');
        div.innerHTML = curHTMLContent;
        var elements = div.childNodes;
     
        for (var i = 0; i < elements.length; i++) {
            
            var curElement = elements[i];
            for (var j = 0; j < curElement.childNodes.length; j++) {
                var curCurElement = curElement.childNodes[j];
                if (curCurElement.tagName == "IMG") {
                    var curUrl = curCurElement.src.toString();
                    if (showMessages) setMessage( "img node found: " +  curUrl );
                    loadImageFromUrl( curUrl );
                }
            }
                
        }
         
        
        
        
        
        // ++++++++++++++++++
        
        // Das Beitragsbild
        var featuredMediaArr = response._embedded['wp:featuredmedia'];
        
        if (featuredMediaArr.length > 0) {
            var caption = response._embedded['wp:featuredmedia'][0].caption.rendered;
            if (showMessages) setMessage( "FeaturedMedia Caption: " +  caption );

            var curUrl = response._embedded['wp:featuredmedia'][0].source_url;
            if (showMessages) setMessage( "FeaturedMedia Link: " +  curUrl );
            
            loadImageFromUrl( curUrl );
            
        }
        
       
        
        if (showMessages) setMessage("Download complete for ID: " + curID);
        
    });
    
    
    
}


function createFlyoutMenu() {
   	
    var csInterface = new CSInterface();
    
	function init() {
        
        csInterface.addEventListener("com.adobe.csxs.events.flyoutMenuClicked", setPanelCallback);
				
		// Flyout menu XML string
        var flyoutXML = "<Menu><MenuItem Id='SettingsMenuItem' Label='Einstellungen...' Enabled='true' Checked='false'/><MenuItem Label='---' /><MenuItem Id='AboutMenuItem' Label='Über WordPress Importer' Enabled='true' Checked='false'/></Menu>";							
     
		// Uses the XML string to build the menu
        csInterface.setPanelFlyoutMenu(flyoutXML, setPanelCallback);
    
        function setPanelCallback(event) {
            
            if (event.type === "com.adobe.csxs.events.flyoutMenuClicked") {
        
                //alert("flyoutMenuClicked: " + event.data.menuName);
                var curVersionObject = csInterface.getCurrentApiVersion();
                var curMajor = curVersionObject.major;
                var curMinor = curVersionObject.minor;
                var curMicro = curVersionObject.micro;

                var curMessageString = "Api Version: " + curMajor + "." + curMinor + "." + curMicro;
                
                var curMenuName = event.data.menuName;
                if (curMenuName == "Über WordPress Importer") {
                    
                    csInterface.evalScript("alert('Einstellungen\\r" + curMessageString + "\\rwww.indesignscript.de\\rHamburg, Germany');");
                    
                }
        
	       }


	   }

    }
    
    init();

}

// Button Bild Laden
function loadPosts() { 
    
    $("#item_list").html('<div align="center"><img src="./css/images/loading.gif" /></div>');
   
    var WPAPI = require( 'wpapi' );

    var curEndpoint = "http://" + document.getElementById("url").value + "/wp-json";
    if (showMessages) setMessage("curEndpoint: " + curEndpoint);
    
    var curUsername = document.getElementById("username").value;
    if (showMessages) setMessage("curUsername: " + curUsername);
    
    var curPassword = document.getElementById("password").value;

    var wp = new WPAPI({ 
        endpoint: curEndpoint, 
        username: curUsername,
        password: curPassword,
        auth: true
    });
     
    wp.posts().get(function( err, response ) {
        
            if ( err ) {
                            
                setMessage("Keine Beiträge geladen.");
                //process.exit(1);
                // handle err 

            }
            
            $("#item_list").empty();
       

            var items = [];

            $.each(response, function(i, item) {
                
                var countItems = i + 1;
                if (isDemo && countItems > 5) {
                    setMessage("Demo: Es werden maximal 5 Beiträge geladen.");
                    return false;
                }
                             
                var renderedTitle = item.title.rendered;
                var id = item.id;
                var link = item.link;
                var testLink;
                var slug = item.slug;

                //items.push('<li><a href="yourlink?id=' + item.id + '">' + item.title + '</a></li>');
                items.push('<li class="topcoat-list__item">'  + renderedTitle + "&nbsp;[" + id + "]&nbsp;&nbsp;" + '<a class="myLink" target="topcoat-displayarea" href="' + link + '">Ansicht</a>' + '</li>');
                
                // target="topcoat-displayarea" funktioniert, wenn ein iFrame im HTML mit dem Namen 'topcoat-displayarea vorhanden ist

            });  //close each();
 
            
            $('#item_list').append( items.join('') );


            var countItemList = $('#item_list li').length;
            setMessage( "WordPress Beiträge geladen: " + countItemList);   
        
    });
    
    

}

function createDocument() {
    
    var csInterface = new CSInterface();
    
    var templatePath = document.getElementById("template").value;
    if (showMessages) setMessage("templatePath: " + templatePath);
   	
      // Funktionsname mit Übergabe einer Variablen
    var evalString = "createDocument(\"" + escape(templatePath) + "\")";

    csInterface.evalScript(evalString, function(result){

            //if (showMessages) 
                setMessage(result);
    });     
    
}



function createDocumentTest() {
    
    var csInterface = new CSInterface();
    
    var templatePath = document.getElementById("template").value;
    if (showMessages) setMessage("templatePath: " + templatePath);
   	
      // Funktionsname mit Übergabe einer Variablen
    var evalString = "createDocument(\"" + escape(templatePath) + "\")";

    csInterface.evalScript(evalString, function(result){

            //if (showMessages) 
                setMessage(result);
    });     
    
}


// Button Bild Laden
function loadImageFromUrl( curUrl ) { 
    
    var fs = require('fs');	
    var http = require('http');       
    var url = require('url');
    
    var a = document.createElement('a');
    a.href = curUrl;
    var curHostName = a.hostname;
    if (showMessages) setMessage("curHostName: " + curHostName); // z.B. "hq.ch.sauter-bc.com"

    var curPathName = a.pathname;
    if (showMessages) setMessage("curPathName: " + curPathName); // z.B. "/medialib/fileadmin/image_11275_2d7f9dc5d001488db1b1749974ed46f3.tif"
  
    url = curHostName + curPathName;
 	//var url = "hq.ch.sauter-bc.com/medialib/fileadmin/image_11275_2d7f9dc5d001488db1b1749974ed46f3.tif";
 	//var fileName = "image_11275_2d7f9dc5d001488db1b1749974ed46f3.tif";

    if (showMessages) setMessage("url: " + url);
    
    // Download Image
    request( curHostName, curPathName ); // z.B. request('hq.ch.sauter-bc.com', '/medialib/fileadmin/image_11275_2d7f9dc5d001488db1b1749974ed46f3.tif');	

}


// Funktion für Aufruf in loadImageFromUrl()

function request(host, curPath) {

    var http = require('http');
    var fs = require('fs');	
    var url = require('url');
    var path = require('path');
    
    var csInterface = new CSInterface();

    var curDownloadFolder = csInterface.getSystemPath(SystemPath.MY_DOCUMENTS);
    if (showMessages) setMessage("curDownloadFolder: " + curDownloadFolder);
    
    // Create Links Folder in Download Folder
    try {
        
        var dir = curDownloadFolder + '/WordPress-Temp';

        if (!fs.existsSync(dir)){
            fs.mkdirSync(dir);
            if (showMessages) setMessage("Links folder created successfully.");
        } else {
            if (showMessages) setMessage("Links folder exists.");
        }

        curDownloadFolder = dir;
        if (showMessages) setMessage("curDownloadFolder: " + curDownloadFolder);

    } catch (e) {
        if (showMessages) setMessage("Create Links folder failed.");
        
    }
   
    http.get({ host: host, path: curPath}, function(response) {
        
        // The page has moved make new request
        if (response.statusCode === 302) {
            if (showMessages) setMessage("Redirect found");

            if (url.parse(response.headers.location).hostname) {
                  // Hostname included; make request to res.headers.location
                // TODO
            } else {
                  // Hostname not included; get host from requested URL (url.parse()) and prepend to location
                  var location = JSON.stringify(response.headers.location);
                  var locationStr = new String();
                  locationStr = location.toString().replace(/"/g, "");

                  if (showMessages) setMessage("curAddress: " + host );
                  if (showMessages) setMessage("curPath: " + curPath);
                  if (showMessages) setMessage("New Request Location: " + locationStr);
                  request(host, locationStr);						  
            }

        } else {

            if (showMessages) setMessage("curAddress2: " + host );
            if (showMessages) setMessage("curPath2: " + curPath );

            if (showMessages) setMessage("Response: " + response.statusCode + "\r");

            // Dateiname holen path und basename von Node.js
            var fileName = path.basename(curPath);
            
            if (showMessages) setMessage("curFileName: " + fileName );

            var fullPath = curDownloadFolder + "/" + fileName;
            if (showMessages) setMessage("Full Path: " + fullPath);

            // Datei schreiben
            var file = fs.createWriteStream(fullPath);

            var curUrl = "http://" + host + "/" + curPath;

            try {
                var anotherrequest = http.get(curUrl , function(response) {
                    
                    response.pipe(file);
                    
                    file.on('finish', function () {
                        
                            if (showMessages) setMessage("Finished Download.");
                        
                            if (showMessages) setMessage("fullPath for place(): " + fullPath);
                            // Funktionsname mit Übergabe einer Variablen
                            var evalString = "placeFile(\"" + escape(fullPath) + "\")";
                            
                            var csInterface = new CSInterface();
                            csInterface.evalScript(evalString, function(result){

                                if (result != "") {
                                    if (showMessages) setMessage(result);
                                } else {
                                    if (showMessages) setMessage("Platzierung beendet.");
                                }
                            });
			
                    });
                                                     

                });
            } catch (e) {
                if (showMessages) setMessage("Error: " + e.toString + "\r");
            }
                      
            if (showMessages) setMessage("++++Complete++++");

        }
    }).on('error', function(err) {
        if (showMessages) setMessage("Error bei 'request' " +  err.message + "\r");
    });
       
}